﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms.VisualStyles;

namespace pl3w
{
    public class SetupVal
    {
        public SetupVal()
        {
            startLine = 1;
            colStatus = "A"; 
            colPrefix = "B";
            colSuffix = "C";
            colPN     = "D";
            colMnf    = "E";
            colMnfPN  = "F";
            colPkg    = "G";
            colNote   = "H";
            colCompInfo = "I";
            colPage = "L";
            colPos = "M";
            colFileName = "N";

            enMnf    = true;
            enMnfPN = true;
            enPkg   = true;
            enNote  = true;
            enCompInfo = true;
            enPage = true;
            enPos = true;
            enFileName = true;


            placeLabel = true;

            err_startLine = true;
            err_colStatus = true;
            err_colPrefix = true;
            err_colSuffix = true;
            err_colPN = true;
            err_colMnf = true;
            err_colMnfPN = true;
            err_colPkg = true;
            err_colNote = true;
            err_colCompInfo = true;
            err_colPage = true;
            err_colPos = true;
            err_colFileName = true;

        }


        //コピーコンストラクタ
        public SetupVal(SetupVal sv) :this()
        {
            startLine = sv.startLine;
            colStatus = sv.colStatus;
            colPrefix = sv.colPrefix;
            colSuffix = sv.colSuffix;
            colPN = sv.colPN;
            colMnf = sv.colMnf;
            colMnfPN = sv.colMnfPN;
            colPkg = sv.colPkg;
            colNote = sv.colNote;
            colCompInfo = sv.colCompInfo;
            colPage = sv.colPage;
            colPos = sv.colPos;
            colFileName = sv.colFileName;

            enMnf = sv.enMnf;
            enMnfPN = sv.enMnfPN;
            enPkg = sv.enPkg;
            enNote = sv.enNote;
            enCompInfo = sv.enCompInfo;
            enPage = sv.enPage;
            enPos = sv.enPos;
            enFileName = sv.enFileName;

            placeLabel = sv.placeLabel;
            titleStatus = sv.titleStatus;
            titlePrefix = sv.titlePrefix;
            titleSuffix = sv.titleSuffix;
            titlePN = sv.titlePN;
            titleMnf = sv.titleMnf;
            titleMnfPN = sv.titleMnfPN;
            titlePkg = sv.titlePkg;
            titleNote = sv.titleNote;
            titleCompInfo = sv.titleCompInfo;
            titlePage = sv.titlePage;
            titlePos = sv.titlePos;
            titleFileName = sv.titleFileName;
        }






        public int startLine;
        public string colStatus;
        public string colPrefix;
        public string colSuffix;
        public string colPN;
        public string colMnf;
        public string colMnfPN;
        public string colPkg;
        public string colNote;
        public string colCompInfo;
        public string colPage;
        public string colPos;
        public string colFileName;

        public string titleStatus;
        public string titlePrefix;
        public string titleSuffix;
        public string titlePN;
        public string titleMnf;
        public string titleMnfPN;
        public string titlePkg;
        public string titleNote;
        public string titleCompInfo;
        public string titlePage;
        public string titlePos;
        public string titleFileName;


        public bool enMnf;
        public bool enMnfPN;
        public bool enPkg;
        public bool enNote;
        public bool enCompInfo;
        public bool enPage;
        public bool enPos;
        public bool enFileName;

        public bool err_startLine;
        public bool err_colStatus;
        public bool err_colPrefix;
        public bool err_colSuffix;
        public bool err_colPN;
        public bool err_colMnf;
        public bool err_colMnfPN;
        public bool err_colPkg;
        public bool err_colNote;
        public bool err_colCompInfo;
        public bool err_colPage;
        public bool err_colPos;
        public bool err_colFileName;

        public bool placeLabel;




        public void Load()
        {
            startLine = Properties.Settings.Default.startLine;
            colStatus = Properties.Settings.Default.columnStatus;
            colPrefix = Properties.Settings.Default.columnRefPrefix;
            colSuffix = Properties.Settings.Default.columnRefSuffix;
            colPN = Properties.Settings.Default.columnPartName;
            colMnf = Properties.Settings.Default.columnMnf;
            colMnfPN = Properties.Settings.Default.columnMnfPN;
            colPkg = Properties.Settings.Default.columnPkg;
            colNote = Properties.Settings.Default.columnNote;
            colCompInfo = Properties.Settings.Default.columnCompInfo;
            colPage = Properties.Settings.Default.columnPage;
            colPos = Properties.Settings.Default.columnPos;
            colFileName = Properties.Settings.Default.columnFileName; 

            placeLabel = Properties.Settings.Default.placeLabel;

            titleStatus = Properties.Settings.Default.titleStatus;
            titlePrefix = Properties.Settings.Default.titleRefPrefix;
            titleSuffix = Properties.Settings.Default.titleRefSuffix;
            titlePN = Properties.Settings.Default.titlePartName;
            titleMnf = Properties.Settings.Default.titleMnf;
            titleMnfPN = Properties.Settings.Default.titleMnfPN;
            titlePkg = Properties.Settings.Default.titlePkg;
            titleNote = Properties.Settings.Default.titleNote;
            titleCompInfo = Properties.Settings.Default.titleCompInfo;
            titlePage = Properties.Settings.Default.titlePage;
            titlePos = Properties.Settings.Default.titlePos;
            titleFileName = Properties.Settings.Default.titleFileName;
           

            enMnf = Properties.Settings.Default.enMnf;
            enMnfPN = Properties.Settings.Default.enMnfPN;
            enPkg = Properties.Settings.Default.enPkg;
            enNote = Properties.Settings.Default.enNote;
            enCompInfo = Properties.Settings.Default.enCompInfo;
            enPage = Properties.Settings.Default.enPage;
            enPos = Properties.Settings.Default.enPos;
            enFileName = Properties.Settings.Default.enFileName;   


        }

        public void Save()
        {
            Properties.Settings.Default.startLine = startLine;
            Properties.Settings.Default.columnStatus = colStatus;
            Properties.Settings.Default.columnRefPrefix = colPrefix;
            Properties.Settings.Default.columnRefSuffix = colSuffix;
            Properties.Settings.Default.columnPartName = colPN;
            Properties.Settings.Default.columnMnf = colMnf;
            Properties.Settings.Default.columnMnfPN = colMnfPN;
            Properties.Settings.Default.columnPkg = colPkg;
            Properties.Settings.Default.columnNote = colNote;
            Properties.Settings.Default.columnCompInfo = colCompInfo;
            Properties.Settings.Default.columnPage = colPage;
            Properties.Settings.Default.columnPos = colPos;
            Properties.Settings.Default.columnFileName = colFileName;


            Properties.Settings.Default.enMnf = enMnf;
            Properties.Settings.Default.enMnfPN = enMnfPN;
            Properties.Settings.Default.enPkg = enPkg;
            Properties.Settings.Default.enNote = enNote;
            Properties.Settings.Default.enCompInfo = enCompInfo;
            Properties.Settings.Default.enPage = enPage;
            Properties.Settings.Default.enPos = enPos;
            Properties.Settings.Default.enFileName = enFileName;

            Properties.Settings.Default.placeLabel = placeLabel;

            Properties.Settings.Default.titleStatus = titleStatus;
            Properties.Settings.Default.titleRefPrefix = titlePrefix;
            Properties.Settings.Default.titleRefSuffix = titleSuffix;
            Properties.Settings.Default.titlePartName = titlePN;
            Properties.Settings.Default.titleMnf = titleMnf;
            Properties.Settings.Default.titleMnfPN = titleMnfPN;
            Properties.Settings.Default.titlePkg = titlePkg;
            Properties.Settings.Default.titleNote = titleNote;
            Properties.Settings.Default.titleCompInfo = titleCompInfo;
            Properties.Settings.Default.titlePage = titlePage;
            Properties.Settings.Default.titlePos = titlePos;
            Properties.Settings.Default.titleFileName = titleFileName;





            Properties.Settings.Default.Save();
        }




        //エラーがないときtrueを返す
        public bool CheckValue()
        {
            int[] cols = new int[12];   //カラムの重複チェック用
            int colIndex = 0;
            bool err = false;
            int n,i;

            err_startLine = (startLine < 1 || startLine > 100);
            err |= err_startLine;

            cols[colIndex++] = n = Utils.ColumnToIndex(colStatus);
            err |= (err_colStatus = (n < 1 || n > 26));


            n = Utils.ColumnToIndex(colPrefix);
            for (i = 0; i < colIndex; i++)
            {
                if (cols[i] == n) break;
            }
            err |= (err_colPrefix = (i < colIndex || n < 1 || n > 26));
            cols[colIndex++] = n;

            n = Utils.ColumnToIndex(colSuffix);
            for (i = 0; i < colIndex; i++)
            {
                if (cols[i] == n) break;
            }
            err |= (err_colSuffix = (i < colIndex || n < 1 || n > 26));
            cols[colIndex++] = n;

            n = Utils.ColumnToIndex(colPN);
            for (i = 0; i < colIndex; i++)
            {
                if (cols[i] == n) break;
            }
            err |= (err_colPN = (i < colIndex || n < 1 || n > 26));
            cols[colIndex++] = n;

            if (enMnf)
            {
                n = Utils.ColumnToIndex(colMnf);
                for (i = 0; i < colIndex; i++)
                {
                    if (cols[i] == n) break;
                }
                err |= (err_colMnf = (i < colIndex || n < 1 || n > 26));
                cols[colIndex++] = n;
            }
            else
            {
                err_colMnf = false;
            }

            if (enMnfPN)
            {
                n = Utils.ColumnToIndex(colMnfPN);
                for (i = 0; i < colIndex; i++)
                {
                    if (cols[i] == n) break;
                }
                err |= (err_colMnfPN = (i < colIndex || n < 1 || n > 26));
                cols[colIndex++] = n;
            }
            else
            {
                err_colMnfPN = false;
            }

            if (enPkg)
            {
                n = Utils.ColumnToIndex(colPkg);
                for (i = 0; i < colIndex; i++)
                {
                    if (cols[i] == n) break;
                }
                err |= (err_colPkg = (i < colIndex || n < 1 || n > 26));
                cols[colIndex++] = n;
            }
            else
            {
                err_colPkg = false;
            }


            if (enNote)
            {
                n = Utils.ColumnToIndex(colNote);
                for (i = 0; i < colIndex; i++)
                {
                    if (cols[i] == n) break;
                }
                err |= (err_colNote = (i < colIndex || n < 1 || n > 26));
                cols[colIndex++] = n;
            }
            else
            {
                err_colNote = false;
            }

            if(enCompInfo)
            {
                n = Utils.ColumnToIndex(colCompInfo);
                for (i = 0; i < colIndex; i++)
                {
                    if (cols[i] == n) break;
                }
                err |= (err_colCompInfo = (i < colIndex || n < 1 || n > 26));
                cols[colIndex++] = n;
            }
            else
            {
                err_colCompInfo = false;
            }

            if (enPage)
            {
                n = Utils.ColumnToIndex(colPage);
                for (i = 0; i < colIndex; i++)
                {
                    if (cols[i] == n) break;
                }
                err |= (err_colPage = (i < colIndex || n < 1 || n > 26));
                cols[colIndex++] = n;
            }
            else
            {
                err_colPage = false;
            }

            if(enPos)
            {
                n = Utils.ColumnToIndex(colPos);
                for (i = 0; i < colIndex; i++)
                {
                    if (cols[i] == n) break;
                }
                err |= (err_colPos = (i < colIndex || n < 1 || n > 26));
                cols[colIndex++] = n;
            }
            else
            {
                err_colPos = false;
            }

            if (enFileName)
            {
                n = Utils.ColumnToIndex(colFileName);
                for (i = 0; i < colIndex; i++)
                {
                    if (cols[i] == n) break;
                }
                err |= (err_colFileName = (i < colIndex || n < 1 || n > 26));
                cols[colIndex++] = n;
            }
            else
            {
                err_colFileName = false;
            }

            return !err;
        }

    }
}
